'Date: 14/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D
Imports System.Drawing

Public Class Engine

    Private Font_Fps As Direct3D.Font
    Private FramesDrawn As Integer
    Private LastTimeCheckFPS As Long

    Public FrameRate As Integer
    Public disposed As Boolean
    Public Tempo, TempoAtc As Integer

    Public Sub New(ByVal Handle As IntPtr, ByVal FullScreen As Boolean, Optional ByVal ResX As Integer = 1024, Optional ByVal ResY As Integer = 768)
        Dim adapterOrdinal As Integer = Microsoft.DirectX.Direct3D.Manager.Adapters.Default.Adapter
        Dim caps As Caps = Microsoft.DirectX.Direct3D.Manager.GetDeviceCaps(adapterOrdinal, Microsoft.DirectX.Direct3D.DeviceType.Hardware)
        Dim createFlags As CreateFlags
        If caps.DeviceCaps.SupportsHardwareTransformAndLight Then
            createFlags = createFlags.HardwareVertexProcessing
        Else
            createFlags = createFlags.SoftwareVertexProcessing
        End If
        Dim PreParameters As PresentParameters
        PreParameters = New PresentParameters

        With PreParameters
            .SwapEffect = SwapEffect.Discard
            .EnableAutoDepthStencil = True

            .AutoDepthStencilFormat = DepthFormat.D16
            .BackBufferCount = 1
            .Windowed = Not FullScreen
            .DeviceWindowHandle = Handle
            .BackBufferWidth = ResX
            .BackBufferHeight = ResY
            .BackBufferFormat = Format.X8R8G8B8
            .PresentationInterval = PresentInterval.Immediate
        End With

        mdev = New Device(adapterOrdinal, DeviceType.Hardware, Handle, createFlags, PreParameters)

        mdev.RenderState.ShadeMode = ShadeMode.Phong
        mdev.Transform.World = Microsoft.DirectX.Matrix.Identity
        mdev.Transform.View = Microsoft.DirectX.Matrix.Identity
        mdev.Transform.Projection = Matrix.PerspectiveFovLH(Geometry.DegreeToRadian(75), 1024 / 768, 0.5, 200)
        mdev.RenderState.CullMode = Cull.CounterClockwise

        mdev.SamplerState(0).MinFilter = TextureFilter.Anisotropic
        mdev.SamplerState(0).MagFilter = TextureFilter.Anisotropic
        mdev.SamplerState(0).MipFilter = TextureFilter.Anisotropic
        mdev.SamplerState(0).MaxAnisotropy = 8
        mdev.SamplerState(1).MinFilter = TextureFilter.Anisotropic
        mdev.SamplerState(1).MagFilter = TextureFilter.Anisotropic
        mdev.SamplerState(1).MipFilter = TextureFilter.Anisotropic
        mdev.SamplerState(1).MaxAnisotropy = 8
        Font_Fps = New Microsoft.DirectX.Direct3D.Font(mdev, New System.Drawing.Font("verdanna", 12, FontStyle.Regular Or FontStyle.Bold, GraphicsUnit.Pixel))

        'fog
        'mdev.RenderState.FogEnable = False
        'mdev.RenderState.FogColorValue = Get_Color(0.6, 0.8, 1, 1)
        'mdev.RenderState.FogTableMode = FogMode.None
        'mdev.RenderState.FogVertexMode = FogMode.Linear
        'mdev.RenderState.RangeFogEnable = True
        'mdev.RenderState.FogStart = 100
        'mdev.RenderState.FogEnd = 512
        mdev.RenderState.AlphaBlendEnable = False
        mdev.RenderState.AlphaTestEnable = False
        mdev.RenderState.Lighting = False
    End Sub




    Public Sub Render_Clear(ByVal Color As Integer)
        mdev.Clear(ClearFlags.Target Or ClearFlags.ZBuffer, Color, 1.0F, 0)
    End Sub

    Public Sub Render_Begin()
        Calculate_Fps()
        mdev.BeginScene()
    End Sub
    Public Sub Render_End()
        Font_Fps.DrawText(Nothing, FrameRate & "Fps", 0, 0, Color.Goldenrod)
        mdev.EndScene()
        mdev.Present()
        Tempo = System.Environment.TickCount - TempoAtc
        TempoAtc = System.Environment.TickCount
    End Sub


    Private Sub Calculate_Fps()
        FramesDrawn += 1
        If System.Environment.TickCount - LastTimeCheckFPS >= 1000& Then
            LastTimeCheckFPS = System.Environment.TickCount
            FrameRate = FramesDrawn
            FramesDrawn = 0&
        End If
    End Sub

    Public Sub Dispose()
        disposed = True
        mdev.Dispose()
        mdev = Nothing
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If disposed = False Then Dispose()
    End Sub
End Class

