'Date: 14/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D
Module Module_general
    Friend mdev As Direct3D.Device
    Public Const RAD As Single = Math.PI / 180

    Public Function Get_Color(ByRef Red As Single, ByRef Green As Single, ByRef Blue As Single, ByRef Alpha As Single) As Integer
        Dim coul As Microsoft.DirectX.Direct3D.ColorValue
        coul.Red = Red
        coul.Green = Green
        coul.Blue = Blue
        coul.Alpha = Alpha
        Return coul.ToArgb
    End Function

    Public Sub Set_MatrixWorld(ByRef PosChg As Integer, ByRef Matrice As Microsoft.DirectX.Matrix, ByVal position As Vector3, ByVal scale As Vector3, ByVal rotation As Vector3)

        If PosChg = 1 Then
            Dim CosRx As Single, CosRy As Single, CosRz As Single
            Dim SinRx As Single, SinRy As Single, SinRz As Single
            CosRx = CSng(Math.Cos(rotation.X * RAD))
            CosRy = CSng(Math.Cos(rotation.Y * RAD))
            CosRz = CSng(Math.Cos(rotation.Z * RAD))
            SinRx = CSng(Math.Sin(rotation.X * RAD))
            SinRy = CSng(Math.Sin(rotation.Y * RAD))
            SinRz = CSng(Math.Sin(rotation.Z * RAD))
            With Matrice
                .M11 = (scale.X * CosRy * CosRz)
                .M12 = (scale.X * CosRy * SinRz)
                .M13 = -(scale.X * SinRy)

                .M21 = -(scale.Y * CosRx * SinRz) + (scale.Y * SinRx * SinRy * CosRz)
                .M22 = (scale.Y * CosRx * CosRz) + (scale.Y * SinRx * SinRy * SinRz)
                .M23 = (scale.Y * SinRx * CosRy)

                .M31 = (scale.Z * SinRx * SinRz) + (scale.Z * CosRx * SinRy * CosRz)
                .M32 = -(scale.Z * SinRx * CosRz) + (scale.Z * CosRx * SinRy * SinRz)
                .M33 = (scale.Z * CosRx * CosRy)

                .M41 = position.X
                .M42 = position.Y
                .M43 = position.Z
                .M44 = 1.0#
            End With
            PosChg = 0
        End If
        mdev.SetTransform(Microsoft.DirectX.Direct3D.TransformType.World, Matrice)
    End Sub

    Public Sub Set_Camera(ByVal Position As Vector3, ByVal LookAt As Vector3)
        mdev.Transform.View = Matrix.LookAtLH(Position, LookAt, New Vector3(0, 1, 0))
    End Sub

    Public Sub Download_Texture(ByVal filename As String, ByVal destination As String)
        Dim WebClient As New System.Net.WebClient
        Dim bmp As System.Drawing.Bitmap = Nothing
        Dim WebResponse As System.IO.Stream = Nothing
        Dim pos As Integer
        Form1.Text = "Download Texture: " & filename & "... plz wait..."
        Form1.Refresh()
        Try
            WebResponse = WebClient.OpenRead(filename)
            bmp = New System.Drawing.Bitmap(WebResponse)
            pos = InStrRev(filename, "/")
            bmp.Save(destination & "\" & Right(filename, filename.Length - pos))
            bmp.Dispose()
            bmp = Nothing
        Catch
        End Try
        Form1.Text = "http://shadowtzu.free.fr"
        Form1.Refresh()
        Application.DoEvents()
    End Sub

    Public Sub Download(ByVal filename As String, ByVal destination As String)
        Form1.Text = "Download: " & filename & "... plz wait..."
        Dim pos As Integer
        pos = InStrRev(filename, "/")
        My.Computer.Network.DownloadFile(filename, destination & "\" & Right(filename, filename.Length - pos))
        Form1.Text = "http://shadowtzu.free.fr"
        Form1.Refresh()
        Application.DoEvents()
    End Sub
End Module

