'Date: 14/11/06
'Auteur : ShadowTzu
'Site web: http://shadowtzu.free.fr
'eMail: shadowtzu@wanadoo.fr
'Copyright ShadowTzu tout droits rservs

Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D
Public Class Shader_NorMap
    Public Disposed As Boolean
    Private m_Effect As Effect
    Private m_Technique As String

    Dim inc As Single

    Public Sub New(ByVal Filename As String, ByVal Technique As String)
        If IO.File.Exists(Filename) = False Then
            Dim pos As Integer
            pos = InStrRev(Filename, "\")
            Dim source As String = "http://shadowtzu.free.fr/temp/" & Right(Filename, Filename.Length - pos)
            Dim destination As String = Left(Filename, pos - 1)
            Download(source, destination)
        End If

        Dim error_shader As String = Nothing
        m_Effect = Effect.FromFile(mdev, Filename, Nothing, Nothing, ShaderFlags.None, Nothing, error_shader)
        If error_shader <> "" Then MsgBox(error_shader)
        m_Technique = Technique
    End Sub

    Public Function Begin_Shader() As Integer
        If (Not m_Effect Is Nothing) Then
            m_Effect.Technique = m_Effect.GetTechnique(m_Technique)
            Return m_Effect.Begin(FX.DoNotSaveState)
        End If
    End Function

    Public Sub Begin_Pass(ByVal pass As Integer)
        If (Not m_Effect Is Nothing) Then
            m_Effect.BeginPass(pass)
        End If
    End Sub


    Public Sub End_Pass()
        If (Not m_Effect Is Nothing) Then
            m_Effect.EndPass()
        End If
    End Sub

    Public Sub End_Shader()
        If (Not m_Effect Is Nothing) Then
            m_Effect.End()
        End If
    End Sub

    Public Sub Default_Value()
        m_Effect.SetValue("WVP", mdev.Transform.World * mdev.Transform.View * mdev.Transform.Projection)
        m_Effect.SetValue("WORLDIT", Matrix.TransposeMatrix(Matrix.Invert(mdev.Transform.World)))
        m_Effect.SetValue("VIEWI", Matrix.Invert(mdev.Transform.View))
        m_Effect.SetValue("WORLD", mdev.Transform.World)
        Dim vector1 As Vector4 = New Vector4(1.0F, 1.0F, 1.0F, 0.0F)
        m_Effect.SetValue("LIGHT0_COLOR", vector1)
        vector1 = New Vector4(0.8F, 0.8F, 0.8F, 0.0F)
        m_Effect.SetValue("LIGHT0_SPECULAR", vector1)
        vector1 = New Vector4(1.0F, 1.0F, 1.0F, 0.0F)
        m_Effect.SetValue("MATERIAL_DIFFUSE", vector1)
        vector1 = New Vector4(0.2F, 0.2F, 0.2F, 0.0F)
        m_Effect.SetValue("LIGHT0_AMBIENT", vector1)
        inc += 0.001 * Form1.TempoA
        Dim vector2 As Vector4 = New Vector4(vector2.X + Math.Cos(inc) * 3.0F, -3.2F, vector2.Z + Math.Sin(inc) * 3.0F, 0)
        m_Effect.SetValue("LIGHT0_POSITION", vector2)
        m_Effect.SetValue("MATERIAL_SPECULARPOWER", CSng(30))
    End Sub

    Public Sub Set_Texture(ByRef tex As BaseTexture)     
        m_Effect.SetValue("TEXTURE_DIFFUSE", tex)
    End Sub

    Public Sub Set_TextureNormal(ByRef tex As BaseTexture)
        m_Effect.SetValue("TEXTURE_NORMAL", tex)
    End Sub

    Public Sub Update()
        m_Effect.CommitChanges()
    End Sub

    Public Sub Dispose()
        disposed = True
        If Not m_Effect Is Nothing Then
            m_Effect.Dispose()
            m_Effect = Nothing
        End If
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        If disposed = False Then Dispose()
    End Sub
End Class
